<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Рейсы
        <div class="card-header-actions">
          <button class="btn btn-primary btn-sm" @click="openAddingModal" :disabled="isDisabled()">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <download-excel
        class   = "btn btn-success pull-right"
        :data   = "itemsExcel"
        :fields = "jsonFields"
        name    = "filename.xls">
        Скачать Excel
      </download-excel>
      <nav>
        <div class="d-flex mb-3 align-items-center">
          <div class="col-4 pl-0">
            <b-form-input v-model="filter" placeholder="Поиск..." />
          </div>
          <div class="col-8">
            <div class="d-flex align-items-center">
              <span class="mr-1">
                от
              </span>
              <datepicker  :language="ru" name="date" clear-button clear-button-icon="fa fa-times" v-model="paginationOptions.dateFrom"></datepicker>
              <span class="mr-1 ml-3">
                до
              </span>
              <datepicker class="ml-2" :language="ru" clear-button clear-button-icon="fa fa-times" name="date" v-model="paginationOptions.dateTo"></datepicker>
              <b-button class="ml-2" variant="primary" @click.prevent="getLogistics(); paginationOptions.page = 1">Применить</b-button>
            </div>
          </div>
        </div>
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="paginationOptions.page">
        <template slot="amount" slot-scope="data">
          {{data.item.bid.length}}
        </template>
      	<template slot="phone" slot-scope="data">
          {{data.item.employee.phone}}
        </template>
        <template slot="city" slot-scope="data">
          <div v-if="data.item.present">
            {{data.item.present.city}}
          </div>
        </template>
        <template slot="employee" slot-scope="data">
          <div v-if="data.item.employee">
            {{data.item.employee.lastName + ' ' + data.item.employee.name}}
          </div>
        </template>
        <template slot="present" slot-scope="data">
          <div v-if="data.item.present">
            {{data.item.present.lastName + ' ' + data.item.present.name}}
          </div>
        </template>
        <template slot="date" slot-scope="data">
          <div v-if="data.item.date">
            {{ dateFormat(data.item.date) }}
          </div>
        </template>
        <template slot="status" slot-scope="data">
          <div v-if="data.item.status === 'storage'">
            <b-badge variant="danger">
              На складе
            </b-badge>
          </div>
          <div v-else-if="data.item.status === 'ship'">
            <b-badge variant="warning">
              В дороге
            </b-badge>
          </div>
          <div v-else-if="data.item.status === 'done'">
            <b-badge variant="success">
              Доставлено
            </b-badge>
          </div>
          <div v-else-if="data.item.status === 'end'">
            <b-badge variant="success">
              Завершен
            </b-badge>
          </div>
        </template>
        <template slot="action" slot-scope="data">
          <b-button title="Редактировать" size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn" :disabled="isDisabled()">
            <i class="icon-pencil"></i>
          </b-button>
          <b-button title="Подробнее" size="sm" @click.stop="toDetailsPage(data.item)" class="mr-1 tableActionbtn" >
            <!-- <router-link :to="{ name: 'LogisticDetails', params: { id: data.item }}">details</router-link> -->
            <i class="icon-eye"></i>
          </b-button>
          <b-button title="Пуш уведомление" size="sm" @click.stop="infoPush(data.item)" class="mr-1 tableActionbtn" :disabled="isDisabled()">
            <i class="fa fa-info-circle"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination @input="$router.push({query: {page: paginationOptions.page}}); getLogistics(); " :total-rows="dataCount" :per-page="paginationOptions.limit" v-model="paginationOptions.page" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons>
        </b-pagination>
      </nav>
    </b-card>

    <b-modal id="addingModal" @hide="resetModal" title="Добавление логистики" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Гос.номер *</label>
          <input type="text" class="form-control" name="govNumber" placeholder="Государственный номер" v-model="addedLogistics.govNumber" v-validate="'required'"></input>
          <span v-show="errors.has('govNumber')" class="text-danger">{{ errors.first('govNumber') }}</span>
        </b-form-group>
        <b-form-group>
          <label>ФИО водителя *</label>
          <b-form-select name="employee" v-model="addedLogistics.employee" :options="employees" v-validate="'required'"/>
          <span v-show="errors.has('employee')" class="text-danger">{{ errors.first('employee') }}</span>
        </b-form-group>
        <b-form-group>
          <label>ФИО представителя *</label>
          <b-form-select name="present" v-model="addedLogistics.present" :options="presents" v-validate="'required'"/>
          <span v-show="errors.has('present')" class="text-danger">{{ errors.first('present') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Куда *</label>
          <b-form-select type="text" name="range" v-model="addedLogistics.range" :options="cities" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('range')" class="text-danger">{{ errors.first('range') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Статус *</label><br/>
          <b-form-select name="status" v-model="addedLogistics.status" :options="statuses" v-validate="'required'"/>
          <span v-show="errors.has('status')" class="text-danger">{{ errors.first('status') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Дата *</label>
          <datepicker :language="ru" name="date" v-model="addedLogistics.date" v-validate="'required'"></datepicker>
          <span v-show="errors.has('date')" class="text-danger">{{ errors.first('date') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Заказы *</label>
          <b-form-select multiple :select-size="4" name="bid" v-model="addedLogistics.bid" :options="bids" class="modalInput" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('bid')" class="text-danger">{{ errors.first('bid') }}</span>
        </b-form-group>
        <hr/>
        <b-form-group>
          <label>Сумма расходов</label>
          <b-form-input type="text" name="summ" placeholder="Сумма" v-model="addedLogistics.summ"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Коментарий</label>
          <b-form-input type="text" name="comment" placeholder="Коментарий" v-model="addedLogistics.comment"></b-form-input>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>

    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование логистики" centered @ok="edit" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Гос.номер *</label><br/>
          <b-form-input type="text" name="govNumber2" placeholder="Гос.номер" v-model="modalInfo.govNumber" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('govNumber2')" class="text-danger">{{ errors.first('govNumber2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>ФИО водителя *</label><br/>
          <b-form-select v-if="modalInfo.employee" name="employee2" v-model="modalInfo.employee._id" :options="employees" v-validate="'required'"/>
          <b-form-select v-else name="employee2" v-model="modalInfo.employee" :options="employees" v-validate="'required'"/>
          <span v-show="errors.has('employee2')" class="text-danger">{{ errors.first('employee2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>ФИО представителя *</label><br/>
          <b-form-select v-if="modalInfo.present" name="present2" v-model="modalInfo.present._id" :options="presents" v-validate="'required'"/>
          <b-form-select v-else name="present2" v-model="modalInfo.present" :options="presents" v-validate="'required'"/>
          <span v-show="errors.has('present2')" class="text-danger">{{ errors.first('present2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Куда *</label>
          <b-form-select type="text" name="range2" v-model="modalInfo.range" :options="cities"></b-form-select>
          <span v-show="errors.has('range2')" class="text-danger">{{ errors.first('range2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Статус *</label><br/>
          <b-form-select name="status2" v-model="modalInfo.status" :options="statuses" v-validate="'required'"/>
          <span v-show="errors.has('status2')" class="text-danger">{{ errors.first('status2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Дата *</label><br/>
          <datepicker name="date2" :language="ru" v-model="modalInfo.date" v-validate="'required'"></datepicker>
          <span v-show="errors.has('date2')" class="text-danger">{{ errors.first('date2') }}</span>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>

    <b-modal id="pushInfo" @hide="resetModal" title="Пуш уведомление" centered @ok="edit" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Заголовок</label>
          <b-form-input class="modalInput" type="text" name="pushInfo.title" placeholder="Заголовок" v-model="pushInfo.title"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Сообщение</label>
          <b-form-input class="modalInput" type="text" name="pushInfo.message" placeholder="Сообщение" v-model="pushInfo.message"></b-form-input>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="sendPush()">Отправить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>

    <b-modal id="modalEnded" title="Уведомление" centered>
      <b-container fluid>
        <b-form-group>
          <label>Нельзя редактировать, так как завершен</label>
        </b-form-group>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import { ru } from 'vuejs-datepicker/dist/locale'
import Api from '@/services/Api'
import Datepicker from 'vuejs-datepicker'

export default {
  name: 'Logistics',
  components: {
    Datepicker
  },
  props: {
    caption: {
      type: String,
      default: 'Логистика'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    },

  },
  data: () => {
    return {
      userLevel: localStorage.getItem('level'),
      ru: ru,
      selected: null,
      items: [],
      itemsExcel: [],
      cities: [],
      statuses: [
        { value: 'storage', text: 'На складе' },
        { value: 'ship', text: 'В дороге' },
        { value: 'done', text: 'Закончен' }
      ],
      jsonFields: {
        'Количество' : 'amount',
        'Номер машины' : 'govNumber',
        'Телефон' : 'phone',
        'Город' : 'city',
        'ФИО водителя' : 'employee',
        'ФИО представителя' : 'present',
        'Дата и время выезда' : 'date',
        'Статус' : 'status'
      },
      fields: [
        { key: 'amount', label: 'Количество' },
        { key: 'govNumber', label: 'Номер машины' },
        { key: 'phone', label: 'Телефон' },
        { key: 'city', label: 'Город' },
        { key: 'employee', label: 'ФИО водителя' },
        { key: 'present', label: 'ФИО представителя' },
        { key: 'date', label: 'Дата и время выезда' },
        { key: 'status', label: 'Статус' },
        { key: 'action', label: 'Действия по данным' }
      ],
      currentPage: 1,
      perPage: 50,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      employees: [],
      contrAgents: [],
      presents: [],
      bids: [],
      bids_selected: [],
      addedLogistics: {
        govNumber: '',
        employee: '',
        present: '',
        range: '',
        status: '',
        date: '',
        bid: [],
        summ: '',
        comment: '',
      },
      modalInfo: {
        _id: '',
        govNumber: '',
        employee: [],
        present: '',
        range: '',
        status: '',
        date: ''
      },
      pushInfo: {
        logisticId: '',
        title: '',
        message: ''
      },
      selected: {
        startDate: '',
        endDate: '',
        text: '',
        type: ''
      },
      dataCount: 0,
      paginationOptions: {
        page: 1,
        limit: 50,
        dateFrom: '',
        dateTo: '',
        sort: '-date'
      },
    }
  },
  computed: {

    disabled () {
      if (this.addedLogistics.govNumber.length > 0 && this.addedLogistics.employee.length > 0
        && this.addedLogistics.present.length > 0 && this.addedLogistics.range.length > 0
        && this.addedLogistics.status.length > 0 && this.addedLogistics.date) {
        return false
      } else {
        return true
      }
    }
  },
  async beforeMount () {
    this.getCities()
    this.getEmployees()
    this.getPresents()
    this.getBids()
    await this.getLogistics()
    this.paginationOptions.page = this.$route.query.page
  },
  methods: {
    isDisabled() {
      return this.userLevel === "2"
    },
    linkGen(pageNum) {
    if (pageNum === 1) {
      return '?'
    } else {
      return '?page=' + pageNum
    }
  },
  getCities () {
    Api().get('getCities').then(response => {
      this.cities = response.data.map(item => {
        return {
          value: 'Алматы - ' + item.name,
          text: 'Алматы - ' + item.name
        }
      })
    })
  },
    async getLogistics () {
      this.paginationOptions.dateFrom = new Date(this.paginationOptions.dateFrom).getTime()||''
      this.paginationOptions.dateTo = new Date(this.paginationOptions.dateTo).getTime()||''
      const response = await Api().post(`getlogistics${this.QS(this.paginationOptions)}`)
      this.logistics = response.data.docs
      this.items = response.data.docs
      this.dataCount = response.data.total
      this.itemsExcel = response.data.docs.map(item => {
        return {
          amount: item.bid.length,
          govNumber: item.govNumber,
          phone: item.employee.phone,
          city: item.present ? item.present.city : '',
          employee: item.employee ? item.employee.lastName + ' ' + item.employee.name : '',
          present: item.present ? item.present.lastName + ' ' + item.present.name: '',
          date: this.dateFormat(item.date),
          status: item.status === 'storage' ? 'На складе' : item.status === 'ship' ? 'В дороге' : item.status === 'done' ? 'Доставлено' : ''
        }
      })
    },
    getPresents () {
      Api().post('getByParameters', {type: 'present'}).then(response => {
        this.presents = response.data.map(item => {
          return { value: item._id, text: item.lastName + ' ' + item.name }
        })
      })
    },
    getBids () {
      Api().get('getactivebids', {status: 'storage'}).then(response => {
        this.bids = response.data.docs.map(item => {
          return {value: item._id, text: item.number}
        })
      })
    },
    getEmployees () {
      Api().post('getByParameters', {position: 'Водитель', type: 'employee'}).then(response => {
        this.employees = response.data.map(item => {
          return { value: item._id, text: item.lastName + ' ' + item.name }
        })
      })
    },
    adding (e) {
      this.$validator.validateAll()
      if (this.validateAdding()) {
        if (this.addedLogistics.summ.length > 0 && this.addedLogistics.comment.length > 0) {
          this.addedLogistics.cause = 'present'
          Api().post('addOutgoes', this.addedLogistics).then(response => {
          })
        }
        Api().post('addlogistics', this.addedLogistics).then(response => {
          window.location.reload()
        })
      }
    },
    edit (e) {
      this.$validator.validateAll()
      if (this.validateEditing()) {
        Api().post('editlogistics', this.modalInfo).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    deleting (_id) {
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('deletinglogistics', {_id}).then(response => {
          if (response.data.n && response.data.n > 0) {
            this.resetModal()
            window.location.reload()
          } else {
            alert('ne udalilsya')
          }
        })
      } else {
        this.resetModal()
      }
    },
    toDetailsPage (item) {
      this.$router.push({
        name: 'LogisticDetails',
        params: {
          id: item._id
        }
      })
    },
    validateAdding () {
      if (this.addedLogistics.govNumber.length > 0 && this.addedLogistics.employee.length > 0
        && this.addedLogistics.present.length > 0 && this.addedLogistics.range.length > 0
        && this.addedLogistics.status.length > 0 && this.addedLogistics.date && this.addedLogistics.bid.length > 0) {
        return true
      } else {
        return false
      }
    },
    validateEditing () {
      if (this.modalInfo.govNumber.length > 0 && this.modalInfo.employee
        && this.modalInfo.present && this.modalInfo.range.length > 0
        && this.modalInfo.status.length > 0 && this.modalInfo.date) {
        return true
      } else {
        return false
      }
    },
    info (_item) {
      this.modalInfo = _item
      this.modalInfo.employee = _item.employee == null ? {_id: '', name: '', lastName : ''} : _item.employee
      this.modalInfo.present = _item.present == null ? {_id: '', name: '', lastName : ''} : _item.present

      if (_item.status === 'end') {
        this.$root.$emit('bv::show::modal', 'modalEnded')
      } else {
        this.$root.$emit('bv::show::modal', 'modalInfo')
      }

    },
    infoPush (_item) {
      this.pushInfo.logisticId = _item._id
      this.$root.$emit('bv::show::modal', 'pushInfo')
    },
    sendPush () {
      Api().post('sendPush', this.pushInfo).then(response => {
        const answer = confirm('Отправлено')
        if (answer) {
          this.resetModal()
          window.location.reload()
        }
        this.resetModal()
        window.location.reload()
      })
    },
    dateFormat (_date) {
      function fmt (n) {
        return n > 9 ? n : '0' + n
      }
      const now = new Date(_date.toString().trim())
      let time = ''
      if (now != 'Invalid Date') {
        _date = fmt(now.getDate()) + '.' + fmt(now.getMonth() + 1) + '.' + fmt(now.getFullYear())
        time = fmt(now.getHours()) + ':' +  fmt(now.getMinutes())
      }

      return _date + ' ' + time
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.date
      // this.currentPage = 3
    },
    resetModal () {
      this.addedLogistics.govNumber = ''
      this.addedLogistics.employeeId = ''
      this.addedLogistics.date = ''
      this.errors.clear()
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    },
    changePagination(){
      // this.$route.params.pageNumber = 1
      // this.$route.params.query = {pageNumber: 4}
      // console.log('--->', this.$route.params.pageNumber)
    },
    QS(json) {
      return (
        "?" +
        Object.keys(json)
          .map(
            key => encodeURIComponent(key) + "=" + encodeURIComponent(json[key])
          )
          .join("&")
      )
    }
  }
}
</script>
<style scoped>

</style>
